--
-- firewood - fai la legna con la motosega pulendo dai rami i tronchi tagliati, tagliando punte ecc. (taglia! taglia!! taglia!!!)
--
-- by @fcelsa
-- 
-- 
-- history 
--  2015 Dicembre
-- 		v. 0.1.0  prima versione preliminare che non fa niente, solo info di debug
--  2016 Gennaio
--      v. 0.9.0  versione sostanzialmente funzionale, non aggiunge soldi in multiplayer
--      v. 0.9.1  sostanziale riscrittura di molte parti anche fondamentali e cambiato il meccanismo di accredito dei soldi. 
--                (verificare comportamento in multiplayer) aggiunto immagine e suono all'accredito dei soldi
--      v. 0.9.2  modificato suono accredito dei soldi con quello di default così è possibile eliminare il wav dalla mod
--      v. 0.9.3  aumenta la quotazione della legna se la media della temperatura della giornata è inferiore a 14
--      v. 0.9.4  aggiunge una piccola quantità di cippato al silos a seguito della vendita della legna (oltre ai soldi)
--      v. 0.9.5  aggiunto scritte su quotazione e pagamento insieme all'immagine popup - la quantità di cippato ora dipende dalla difficoltà di gioco
--      v. 0.9.6  aggiunto il metro durante i tagli verticali
--      v. 0.9.7  aggiunto localizzazioni, ripulito e/o commentato il codice di debug per eventuale pubblicazione
--      v. 1.0.0  22/01/2016 - parziale fix del metro, ora si azzera dopo ogni taglio verticale. 
--                           - pubblicata versione per test
--      v. 1.0.1  fix: visualizzazione hud, corretto altezza visualizzazione overlay e info.
--      v. 1.1.0  l'HUD ora viene visualizzato sempre utilizzando la motosega; aggiunto overlay di sfondo e ridotto la dimensione del bancale. 
--                Ottimizzato tutti i file grafici dds ed il codice 
--

firewood = {
	segaon = nil;
	cutOn = false;
	cutSt = false;
	cutHz = false;
	cutDl = false;
	misura = 0;
	fontSize = 0.014;
	statString = " ";
	econStringA = " ";
	econStringB = " ";
	cutCNT = 0;
	defCNT = 0;
	pagLegna = 0;
	dir = g_currentModDirectory;
	crncySign = "  € ";
}

local modItem = ModsUtil.findModItemByModName(g_currentModName);
firewood.version = (modItem and modItem.version) and modItem.version or "?.?.?";

function firewood:loadMap(name)
	if g_client == nil then
		return;
	end;
	if (firewood.segaon == nil) then
		firewood.segaon = false;
	end;
	self.woodOverlay = createImageOverlay(Utils.getFilename("legna.dds",firewood.dir));
	self.bgOverlay = createImageOverlay(Utils.getFilename("overlay.dds",firewood.dir));
	self.woodOverlayTime = 0;
	
	-- da fare... come si determina la valuta di gioco ? per ora mi limito a cambiare € in $ ...
	--local moneyChangeId = getMoneyTypeId();
	--print("firewood mod: (to do set) set correct currency for game language " .. string.lower(g_languageShort) .. "  id " .. moneyChangeId );
	if string.lower(g_languageShort) == "en" then 
		firewood.crncySign = "  $ ";
	end;
end;

function firewood:deleteMap()
end;

function firewood:mouseEvent(posX, posY, isDown, isUp, button)
	-- attivo e disattivo il controllo del taglio della legna
	if isDown and button == 1 then
		if (not firewood.segaon) then
            local p = nil;
            if g_currentMission.player ~= nil then
                p = g_currentMission.player.rootNode;
            end;
            if p ~= nil then
				if g_currentMission.player.usesChainsaw then
					firewood.segaon = true;
					aX1, aY1, aZ1 = getWorldTranslation(p);
				else
					firewood.segaon = false;
				end;
            else
                print("firewood mod in esecuzione... player non ancora disponibile");
            end;
        end;
	end;

end;

function firewood:keyEvent(unicode, sym, modifier, isDown)
end;

function firewood:update(dt)
    -- se taglio attivo...
    if firewood.segaon then
		local addmoney = 0;
		local addchip = 0;
		local p = nil;
		pagLegna = firewood.getFirewoodPrice()
		
        if g_currentMission.player ~= nil then
            p = g_currentMission.player.rootNode;
        end;
        -- siamo sicuri che il player esiste?
        if p ~= nil then
			if g_currentMission.player.usesChainsaw then
				firewood.cutOn = g_currentMission.player.currentTool.isCutting;
				firewood.cutSt = g_currentMission.player.currentTool.waitingForResetAfterCut;
				firewood.cutHz = g_currentMission.player.currentTool.isHorizontalCut;
				firewood.cutDl = g_currentMission.player.currentTool.particleSystems.isEmitting;				
				-- coordinate player e calcolo metri di taglio.
				local bX, bY, bZ = getWorldTranslation(p);
				local c2 = ( math.pow( (aX1 - bX), 2 ) + math.pow( (aZ1 - bZ), 2 ) );
				firewood.misura = math.sqrt( ( c2 + math.abs( (aY1 - bY), 2 ) ) );
				firewood.misura = math.floor(firewood.misura * 100 + 0.5) / 100;
				firewood.statString = g_i18n:getText('FW_LEGNA') .. " Kg " .. tostring(firewood.cutCNT);
			else
				firewood.segaon = false;
				firewood.misura = 0;
			end;
			-- tagli verticali...
			if firewood.cutDl and not(firewood.cutHz) then
				if math.random(8) > 5 then
					firewood.cutCNT = firewood.cutCNT + 1;
				end;
			end;
			-- sto defogliando...
			if not(firewood.cutOn) and firewood.cutDl then
				if math.random(8) > 5 then
					firewood.cutCNT = firewood.cutCNT + 1;
				end;
				firewood.defCNT = firewood.defCNT + 1;
			end;
			-- almeno un taglio ed una defogliatura e' finito...
			if firewood.cutSt and firewood.defCNT > 200 and not(firewood.cutDl) then
				
				addmoney = math.floor((pagLegna * firewood.cutCNT) / 1000);
				addchip = math.floor(firewood.cutCNT / (g_currentMission.missionStats.difficulty*1.20));
				
				self.woodOverlayTime = 6000;
				playSample(g_currentMission.cashRegistrySound, 1, 1, 0);
				
				-- n.b. in multiplayer funziona solo per chi ha lanciato il server e su server dedicato non dovrebbe funzionare
				g_currentMission:addSharedMoney(addmoney, "other");
				g_currentMission:addMoneyChange(addmoney, FSBaseMission.MONEY_TYPE_SINGLE, true);
				-- aggiungo cippato al silo
				g_currentMission:setSiloAmount(Fillable.FILLTYPE_WOODCHIPS, g_currentMission:getSiloAmount(Fillable.FILLTYPE_WOODCHIPS) + addchip );
				
				firewood.econStringA = g_i18n:getText('FW_PREZZO') .. firewood.crncySign .. tostring(pagLegna) .. " / t.";
				firewood.econStringB = g_i18n:getText('FW_PAGAM') .. firewood.crncySign .. tostring(addmoney) .. "\n" .. g_i18n:getText('FW_CIPP') .. "\n  l. " .. tostring(addchip);
	
				-- print("prezzo legna: " .. tostring(pagLegna));
				-- print("legna kg " .. tostring(firewood.cutCNT) .. "  pagamento calcolato € " .. tostring(addmoney) .. " + cippato " .. tostring(addchip));
				
				firewood.cutCNT = 0;
				firewood.defCNT = 0;
			end;
			
			-- se i tagli sono orizzontali, es. abbattimento del tronco, non attivo la misura
			if firewood.cutHz then 
				firewood.misura = 0;
			end;
			
			-- azzero la misura dopo la fine di un taglio e reimposto la posizione
			if firewood.cutSt then 
				firewood.misura = 0;
				aX1, aY1, aZ1 = getWorldTranslation(p);
			end;
			
        else
            firewood.segaon = false;
        end;

    end;
	
	if self.woodOverlayTime > 0 then
		self.woodOverlayTime = self.woodOverlayTime - dt;
	end;
	
end;

function firewood:draw()
	
	local povlX = g_currentMission.weatherTimeBackgroundOverlay.x
	local povlY = g_currentMission.weatherTimeBackgroundOverlay.y - 0.22
	
	if g_currentMission.showHelpText then
		posX = firewood.getPosX();
		posY = firewood.getPosY();
		if firewood.segaon then
			if firewood.cutCNT < 1000 then 
				setTextColor(0, 0.40, 0.20, 1);
			else
				setTextColor(0.99, 0.08, 0, 1);
			end;
			setTextAlignment(RenderText.ALIGN_LEFT);
			renderText(posX, posY, firewood.fontSize, firewood.statString );
			firewood.resetSetRendOpt();
		end;
	end;

	if g_currentMission.renderTime and firewood.segaon then
			
		renderOverlay(self.bgOverlay, povlX, povlY, (256/g_screenWidth)*1.6, 256/g_screenHeight/1.3);
		renderOverlay(self.woodOverlay, povlX, povlY, 256/g_screenWidth/1.4, 256/g_screenHeight/1.4);
		setTextBold(true);
		setTextColor(0.95, 0.95, 0.95, 1);
		renderText(povlX+0.09, povlY+0.15, firewood.fontSize, firewood.econStringA);
		renderText(povlX+0.012, povlY+0.01, firewood.fontSize, firewood.statString);
		if self.woodOverlayTime > 0 then
			renderText(povlX+0.09, povlY+0.11, firewood.fontSize, firewood.econStringB);
		end;
		if firewood.misura > 0.5 then 
			setTextColor(0.95, 0.95, 0.95, 1);
			renderText(0.55, 0.12, 0.024, " m. " .. tostring(firewood.misura));
			firewood.resetSetRendOpt();
		end;	
		firewood.resetSetRendOpt();
	end;
	
end;

function firewood.getPosX()
	-- return g_currentMission.moneyBackgroundOverlay.x + math.floor(g_currentMission.moneyBackgroundWidth / 3);
	-- return 0.045;
	return g_currentMission.hudHelpContentOverlay.x + 0.025;
end;

function firewood.getPosY()
	--return g_currentMission.moneyBackgroundOverlay.y + (firewood.fontSize/4);
	return 0.955 - g_currentMission.hudHelpContentOverlay.height;
end;

function firewood.getFirewoodPrice()
	-- qui l'intenzione sarebbe di elaborare il prezzo medio corrente del cippato... ma ancora non ho capito come farlo... :)
	local przLegna = math.floor(360 / g_currentMission.missionStats.difficulty);
	-- aumenta il prezzo se la temperatura media della giornata è 14 o meno gradi
	local temperature = math.floor((g_currentMission.environment.weatherTemperaturesDay[1] + g_currentMission.environment.weatherTemperaturesNight[1]) / 2 );
	if temperature <= 14 then 
		przLegna = math.floor(przLegna + (przLegna * (0.30/g_currentMission.missionStats.difficulty))); 
	end;
	return przLegna;
end;

function firewood.resetSetRendOpt()
	-- per sicurezza reset settaggi text a beneficio delle altre mod
	setTextAlignment(RenderText.ALIGN_LEFT);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
end;

addModEventListener(firewood);
print(string.format("Script loaded: firewood.lua (v%s)", firewood.version));

